Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QPoint

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QPoint

All Implemented Interfaces:
  QtJambiInterface

    public class QPoint

extends QtJambiObject

The `QPoint` class defines a point in the plane using integer precision.

A point is specified by a x coordinate and an y coordinate which can be accessed using the `x` and `y` functions. The `isNull` function returns true if both x and y are set to 0. The coordinates can be set (or altered) using the `setX` and `setY` functions, or alternatively the rx() and ry() functions which return references to the coordinates (allowing direct manipulation).

Given a point p, the following statements are all equivalent:

        QPoint p;

        p.setX(p.x() + 1);
        p += QPoint(1, 0);
        p.rx()++;

A `QPoint` object can also be used as a vector: Addition and subtraction are defined as for vectors (each component is added separately). A `QPoint` object can also be divided or multiplied by an `int` or a `qreal`.

In addition, the `QPoint` class provides the `manhattanLength` function which gives an inexpensive approximation of the length of the `QPoint` object interpreted as a vector. Finally, `QPoint` objects can be streamed as well as compared.

See Also:
  `QPointF`, `QPolygon`

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Constructor Summary
`QPoint()` Constructs a null point, i.e. with coordinates (0, 0)
`QPoint(int xpos, int ypos)` Constructs a point with the given coordinates (`xpos`, `ypos`).

Method Summary
`QPoint` | `add(QPoint p)` Adds this QPoint to `p` and returns the result.
`QPoint` | `divide(double d)` Divides this QPoint by divisor `d` and returns the result.
`boolean` | `equals(java.lang.Object other)`
`static QPoint` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QPoint instance pointed to by nativePointer
`boolean` | `isNull()` Returns true if both the x and y coordinates are set to 0, otherwise returns false.
`int` | `manhattanLength()` Returns the sum of the absolute values of `x` and `y`, traditionally known as the "Manhattan length" of the vector from the origin to the point.
`QPoint` | `multiply(double d)` Multiplies this QPoint by factor `d` and returns the result.
`static QNativePointer` | `nativePointerArray(QPoint[] array)` This function returns a QNativePointer that is pointing to the specified QPoint array.
`void` | `readFrom(QDataStream arg__1)` Reads a QPoint from arg__1.
`void` | `setX(int x)` Sets the x coordinate of this point to the given `x` coordinate.
`void` | `setY(int y)` Sets the y coordinate of this point to the given `y` coordinate.
`QPoint` | `subtract(QPoint p)` Subtracts this QPoint by `p` and returns the result.
`void` | `writeTo(QDataStream arg__1)` Writes thisQPoint to arg__1.
`int` | `x()` Returns the x coordinate of this point.
`int` | `y()` Returns the y coordinate of this point.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QPoint

    public QPoint()

  Constructs a null point, i.e. with coordinates (0, 0)

  See Also:
    `isNull`

### QPoint

    public QPoint(int xpos,
                  int ypos)

  Constructs a point with the given coordinates (`xpos`, `ypos`).

  See Also:
    `setX`, `setY`

Method Detail

### isNull

    public final boolean isNull()

  Returns true if both the x and y coordinates are set to 0, otherwise returns false.

### manhattanLength

    public final int manhattanLength()

  Returns the sum of the absolute values of `x` and `y`, traditionally known as the "Manhattan length" of the vector from the origin to the point. For example:

          QPoint oldPosition;

          MyWidget::mouseMoveEvent(QMouseEvent *event)
          {
              QPoint point = event->pos() - oldPosition;
              if (point.manhattanLength() > 3)
                  // the mouse has moved more than 3 pixels since the oldPosition
          }

  This is a useful, and quick to calculate, approximation to the true length:

          int trueManhattanLength = sqrt(pow(x(), 2) + pow(y(), 2));

  The tradition of "Manhattan length" arises because such distances apply to travelers who can only travel on a rectangular grid, like the streets of Manhattan.

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQPoint to arg__1.

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QPoint from arg__1.

### setX

    public final void setX(int x)

  Sets the x coordinate of this point to the given `x` coordinate.

  See Also:
    `x`, `setY`

### setY

    public final void setY(int y)

  Sets the y coordinate of this point to the given `y` coordinate.

  See Also:
    `y`, `setX`

### x

    public final int x()

  Returns the x coordinate of this point.

  See Also:
    `setX`, `rx`

### y

    public final int y()

  Returns the y coordinate of this point.

  See Also:
    `setY`, `ry`

### fromNativePointer

    public static QPoint fromNativePointer(QNativePointer nativePointer)

  This function returns the QPoint instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

### nativePointerArray

    public static QNativePointer nativePointerArray(QPoint[] array)

  This function returns a QNativePointer that is pointing to the specified QPoint array.

  Parameters:
    `array` - the array that the returned pointer will point to.
  Returns:
    a QNativePointer that is pointing to the specified array.

### equals

    public boolean equals(java.lang.Object other)

  Overrides:
    `equals` in class `java.lang.Object`

### multiply

    public final QPoint multiply(double d)

  Multiplies this QPoint by factor `d` and returns the result. `d`

  Returns:

### divide

    public final QPoint divide(double d)

  Divides this QPoint by divisor `d` and returns the result.

### add

    public final QPoint add(QPoint p)

  Adds this QPoint to `p` and returns the result.

### subtract

    public final QPoint subtract(QPoint p)

  Subtracts this QPoint by `p` and returns the result.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD